require 'jenkins_tracker'
require_relative 'java_plugins'


class PivotalTrackerBuildNotifier

  attr_reader :build, :listener, :pt_publisher

  def initialize(build, listener, pt_publisher)
    @build        = build
    @listener     = listener
    @pt_publisher = pt_publisher
  end

  def notify!
    # only send if the build was successful
    return unless build_was_successful?

    JenkinsTracker::Base.new(
      :changelog_file => expand_value(pt_publisher.changelog_file),
      :tracker_token  => expand_value(pt_publisher.tracker_token),
      :job_name       => expand_value(pt_publisher.job_name),
      :build_url      => expand_value(pt_publisher.build_url)
    ).integrate_job_with_tracker(expand_value(pt_publisher.tracker_project_id))
  end


  private

  def build_was_successful?
    build.native.getResult.to_s == 'SUCCESS'
  end

  def expand_value(value)
    TokenMacroJavaPlugin.expand_value(build, listener, value)
  end

end